%% FourierFlugzeug
% Fourier-Analyse des Lrms in einem Propellerflugzeug 
% Bombardier-Q400 (DH4), engine PW 150, max. Propellerdrehzahl 1200 RPM

%% Einlesen einer Video-Datei 
% uebernommen aus der Matlab-Dokumentation, Thema "Read Video Files"

% Construct a VideoReader object associated with the sample file.
vidObj = VideoReader('propeller.mp4');
% Determine the height and width of the frames.
vidHeight = vidObj.Height;
vidWidth = vidObj.Width;
% Create a MATLAB movie structure array, s.
s = struct('cdata',zeros(vidHeight,vidWidth,3,'uint8'),...
    'colormap',[]);
% Read one frame at a time using readFrame until the end of the file is
% reached. Append data from each video frame to the structure array.

k = 1;
while hasFrame(vidObj)
    s(k).cdata = readFrame(vidObj);
    k = k+1;
end

% Get information about the movie structure array, s.
whos s

%Display the fifth frame stored in s.
image(s(5).cdata)

% Resize the current figure and axes based on the video's width and height.
% Then, play the movie once at the video's frame rate using the movie
% function.

%%
set(gcf,'position',[150 150 vidObj.Width vidObj.Height]);
set(gca,'units','pixels');
set(gca,'position',[0 0 vidObj.Width vidObj.Height]);
movie(s,1,vidObj.FrameRate);
% % Close the figure.

close
%% Einlesen einer Audio-Datei
% y ist Amplitudenvektor, fs die Abtastrate
[y,fs] = audioread('propeller.mp4');

% so hrt sich das an
sound(y,fs)

% y enthaelt ueber 170000 Datenpunkte; wir waehlen ein Datenfenster der
% Laenge 2^17
start=1000;
window=2^17;
y = y(start+1:start+window);

% der t-Vektor enthaelt Zeit-Daten(in Sekunden)
t=(0:length(y)-1)/fs;
plot(t,y)

%% Fouriertransformation
% Y(1)/N ist der Mittelwert.
% Y(2:N/2+1) enthaelt Information zu den Frequenzen fs/N bis fs/2
N=length(y);
Y = fft(y);
f = linspace(0,fs/2,N/2+1); % die zu Y gehoerigen Frequenzen

%% Plot zeigt Frequenzpeaks
% Grundfrequenz bei ca. 85 Hz, und verschiedene Obertoene
semilogy(f,abs(Y(1:N/2+1)))
axis([0,2000,1,inf])

% sechsblttriger Propeller, Grundfrequenz daher 6-fache Dreh-frequenz!